Index: src/uk/me/parabola/mkgmap/reader/osm/xml/Osm5XmlHandler.java
===================================================================
--- src/uk/me/parabola/mkgmap/reader/osm/xml/Osm5XmlHandler.java	(revision 1049)
+++ src/uk/me/parabola/mkgmap/reader/osm/xml/Osm5XmlHandler.java	(working copy)
@@ -314,6 +314,31 @@
 							log.info("Making opposite cycleway '" + cycleWay.getTag("name") + "'");
 						}
 					}
+
+					if("pedestrian".equals(highway) ) {
+
+						String pedestrianAreaTag = currentWay.getTag("area");
+						
+						if("yes".equals(pedestrianAreaTag)) {
+
+							// Add extra footway around pedestrian square for routing
+							long pedestrianId = currentWay.getId() + CYCLEWAY_ID_OFFSET;
+							Way pedestrianWay = new Way(pedestrianId);
+							wayMap.put(pedestrianId, pedestrianWay);
+							List<Coord> points = currentWay.getPoints();
+							for(int i = 0; i < points.size(); ++i)
+								pedestrianWay.addPoint(points.get(i));
+			
+							pedestrianWay.copyTags(currentWay);
+							pedestrianWay.addTag("name", currentWay.getTag("name") + " (pedestrian)");
+							pedestrianWay.addTag("area", "no");
+
+							log.info("Making routable pedestrian way from area '" + pedestrianWay.getTag("name") + "'");
+
+						}
+					}
+
+
 				}
 				if("motorway".equals(highway) ||
 				   "trunk".equals(highway))
